( cd usr/sbin ; rm -rf grub-update )
( cd usr/sbin ; ln -sf update-grub grub-update )
( cd usr/share/grub ; rm -rf dejavusansmono.pf2 )
( cd usr/share/grub ; ln -sf /boot/grub/fonts/dejavusansmono.pf2 dejavusansmono.pf2 )
( cd usr/share/grub ; rm -rf dejavusansmonobold.pf2 )
( cd usr/share/grub ; ln -sf /boot/grub/fonts/dejavusansmonobold.pf2 dejavusansmonobold.pf2 )
( cd usr/share/grub ; rm -rf hack.pf2 )
( cd usr/share/grub ; ln -sf /boot/grub/fonts/hack.pf2 hack.pf2 )
( cd usr/share/grub ; rm -rf hackbold.pf2 )
( cd usr/share/grub ; ln -sf /boot/grub/fonts/hackbold.pf2 hackbold.pf2 )

config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    # Also preserve timestamp:
    touch -r $NEW ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

# Process config files in etc/grub.d/:
for file in etc/grub.d/*.new ; do
  preserve_perms $file
  # Move it into place. These are not intended to be edited locally - make new custom scripts!
  # We'll skip moving 40_custom.new, though.
  if [ -r $file -a ! "$file" = "etc/grub.d/40_custom.new" ]; then
    mv $file $(dirname $file)/$(basename $file .new)
  fi
done
config etc/default/grub.new

# If there's a Slackware GRUB install script and it's executable, run it.
# None of this will happen when this package is installed from the installer
# since the script doesn't exist yet, but we'll deal with that special case
# after all the packages are installed and GRUB is configured.
if [ -r etc/default/grub ]; then
  . etc/default/grub
  # Also allow overrides from the grub.d directory:
  for dropin in etc/default/grub.d/*.cfg ; do
    if test -f "${dropin}" ; then
      . "${dropin}"
    fi
  done
  # If the install script exists and is executable, run it:
  if [ -x "$GRUB_INSTALL_SCRIPT" ]; then
    $GRUB_INSTALL_SCRIPT
  fi
fi
